=== debian/changelog ===
qucs (0.0.18.140626-3) utopic; urgency=medium

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 26 Jun 2014 13:13:17 +0200

qucs (0.0.18.140626-2) trusty; urgency=medium

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 26 Jun 2014 13:12:54 +0200

qucs (0.0.18.140626-1) saucy; urgency=medium

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 26 Jun 2014 11:48:39 +0200

qucs (0.0.18.140124-4) saucy; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 24 Jan 2014 10:55:22 +0100

qucs (0.0.18.140124-3) raring; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 24 Jan 2014 10:54:50 +0100

qucs (0.0.18.140124-2) quantal; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 24 Jan 2014 10:54:16 +0100

qucs (0.0.18.140124-1) precise; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 24 Jan 2014 10:52:03 +0100

qucs (0.0.18.140114-4) saucy; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Tue, 14 Jan 2014 13:31:53 +0100

qucs (0.0.18.140114-3) raring; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Tue, 14 Jan 2014 13:16:53 +0100

qucs (0.0.18.140114-2) quantal; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Tue, 14 Jan 2014 12:01:17 +0100

qucs (0.0.18.140114-1) precise; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Tue, 14 Jan 2014 10:03:03 +0100

qucs (0.0.18.131202-4) saucy; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Mon, 02 Dec 2013 08:41:24 +0100

qucs (0.0.18.131202-3) raring; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Mon, 02 Dec 2013 08:40:47 +0100

qucs (0.0.18.131202-2) quantal; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Mon, 02 Dec 2013 08:40:15 +0100

qucs (0.0.18.131202-1) precise; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Mon, 02 Dec 2013 08:06:52 +0100

qucs (0.0.18.131128-4) saucy; urgency=low

  * Some fixes in Graphics export dialog

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 28 Nov 2013 20:27:29 +0100

qucs (0.0.18.131128-3) raring; urgency=low

  * Some fixes in Graphics export dialog

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 28 Nov 2013 20:26:16 +0100

qucs (0.0.18.131128-2) quantal; urgency=low

  * Some fixes in Graphics export dialog

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 28 Nov 2013 20:25:04 +0100

qucs (0.0.18.131128-1) precise; urgency=low

  * Some fixes in Graphics export dialog

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 28 Nov 2013 20:22:58 +0100

qucs (0.0.18.131121.1-4) saucy; urgency=low

  * Added required QSvg library

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 15:05:26 +0100

qucs (0.0.18.131121.1-3) raring; urgency=low

  * Added required QSvg library

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 15:04:53 +0100

qucs (0.0.18.131121.1-2) quantal; urgency=low

  * Added required QSvg library

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 15:04:18 +0100

qucs (0.0.18.131121.1-1) precise; urgency=low

  * Added required QSvg library

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 15:03:29 +0100

qucs (0.0.18.131121-4) saucy; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 14:21:16 +0100

qucs (0.0.18.131121-3) raring; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 14:20:44 +0100

qucs (0.0.18.131121-2) quantal; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Thu, 21 Nov 2013 14:20:05 +0100

qucs (0.0.18.131121-1) precise; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com> Thu, 21 Nov 2013 14:19:26 +0100

qucs (0.0.18.130925-4) saucy; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 25 Sep 2013 18:54:21 +0200

qucs (0.0.18.130925-3) raring; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 25 Sep 2013 18:52:44 +0200

qucs (0.0.18.130925-2) quantal; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 25 Sep 2013 18:51:44 +0200

qucs (0.0.18.130925-1) precise; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 25 Sep 2013 18:50:15 +0200

qucs (0.0.18.130915-3) raring; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Sun, 15 Sep 2013 20:15:03 +0200

qucs (0.0.18.130915-2) quantal; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Sun, 15 Sep 2013 20:13:58 +0200

qucs (0.0.18.130915-1) precise; urgency=low

  * snapshot

 -- Frans Schreuder <fransschreuder@gmail.com>  Sun, 15 Sep 2013 17:36:32 +0200

qucs (0.0.18.130705-3) raring; urgency=low

  * Fixed output messages

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 05 Jul 2013 08:25:13 +0200

qucs (0.0.18.130705-2) quantal; urgency=low

  * Fixed output messages

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 05 Jul 2013 08:24:04 +0200

qucs (0.0.18.130705-1) precise; urgency=low

  * Fixed output messages

 -- Frans Schreuder <fransschreuder@gmail.com>  Fri, 05 Jul 2013 08:18:20 +0200

qucs (0.0.18.130703.1-3) raring; urgency=low

  * Fixed qucs application path detection

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 03 Jul 2013 08:58:35 +0200

qucs (0.0.18.130703.1-2) quantal; urgency=low

  * Fixed qucs application path detection

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 03 Jul 2013 08:57:36 +0200

qucs (0.0.18.130703.1-1) precise; urgency=low

  * Fixed qucs application path detection

 -- Frans Schreuder <fransschreuder@gmail.com>  Wed, 03 Jul 2013 08:46:40 +0200

qucs (0.0.18.130703-3) raring; urgency=low

  * Fixed bugs #108, #114, #112

